InitSprite()
InitKeyboard()
InitMouse()

If OpenScreen(800,600,32,"TEST") = 0    ; test 32bit
 If OpenScreen(800,600,24,"TEST") = 0   ; if 32bit failed, test 24bit
  If OpenScreen(800,600,16,"TEST") = 0  ; if 32/24 failed, try 16bit screen
     MessageRequester("ERROR","Cant open 16/24/32bit Screen",0):End
  EndIf
 EndIf
EndIf

   ; limit Speed
   ;;SetFrameRate(20)

   ; Load Anim-Sprites
   CatchSprite(1,?Soldier,0)
   TransparentSpriteColor(1,RGB(255,255,255))
   CreateAnimSprite(Soldier.AnimSprite,1,57,59)
   SoldierX = 500 : SoldierY = 400

   CatchSprite(2,?Fighter,0)
   TransparentSpriteColor(2,RGB(255,255,255))
   CreateAnimSprite(Fighter.AnimSprite,2,119,89)
   FighterX = 400 : FighterY = 380



Repeat
     FlipBuffers()
     If IsScreenActive()
       ClearScreen(RGB($66,$66,$66))
       If StartDrawing(ScreenOutput())
         DrawingMode(1)
         DrawText(100, 100,"Please press key: cursor right ->")
         StopDrawing()
       EndIf


       R = 0 : G = 0 : B = 0

       DisplayAnimSprite(Soldier,SoldierX,SoldierY)
       DisplayAnimSprite(Fighter,FighterX,FighterY)
       
       If CollisionAnimAnim(Fighter,FighterX,FighterY,Soldier,SoldierX,SoldierY) : Dead=1 : EndIf
       If Dead = 1
          NextAnimFrame(Soldier): Frame + 1
          If Frame = 10: Quit = 1: EndIf
       EndIf
       If DoAnim = 1: NextAnimFrame(Fighter): EndIf


       ; KEYBOARD CHECK
       ;
       ExamineKeyboard()
       If KeyboardPushed(#PB_Key_Right): DoAnim = 1: EndIf
       Delay(50)
   Else
       Delay(200)
   EndIf
Until KeyboardPushed(#PB_Key_Escape)

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
   Beep_(1400,50)
CompilerEndIf 

Delay(1500)
End

Soldier:
IncludeBinary "Soldier.bmp"
Fighter:
IncludeBinary "Fighter.bmp"
 