InitSprite()
InitKeyboard()
InitMouse()

If OpenScreen(800,600,32,"TEST") = 0    ; test 32bit
 If OpenScreen(800,600,24,"TEST") = 0   ; if 32bit failed, test 24bit
  If OpenScreen(800,600,16,"TEST") = 0  ; if 32/24 failed, try 16bit screen
     MessageRequester("ERROR","Cant open 16/24/32bit Screen",0):End
  EndIf
 EndIf
EndIf

   ; limit Speed
   SetFrameRate(15)

   ; Load Anim-Sprites
   CatchSprite(1,?Sonic,0)
   TransparentSpriteColor(1,RGB(255,0,255))
   CreateAnimSprite(Sonic.AnimSprite,1,40,40,80)

   CatchSprite(2,?Rings,0)
   TransparentSpriteColor(2,0)
   CreateAnimSprite(Rings.AnimSprite,2,16,16,100)

   CatchSprite(3,?MineAnim,0)
   TransparentSpriteColor(3,0)
   CreateAnimSprite(MineAnim.AnimSprite,3,64,64,100)


; Variables
SonicX = 80
SonicY = 200
Dim RingsX(100)
Dim RingsY(100)
Dim RingsHideFlag(100)

; Init Position of Rings
For a = 1 To 100
   RingsX(a) = Random(800)
   RingsY(a) = Random(600)
Next a


Repeat
     FlipBuffers()
       ClearScreen(RGB(R,G,B))
       R = 0 : G = 0 : B = 0

       ; Display Rings
       For a = 1 To 100
        If RingsHideFlag(a) = 0
          DisplayAnimSprite(Rings,RingsX(a),RingsY(a))
        EndIf
       Next a

       ; Animate and Display Sonic
       DisplayAnimSprite(Sonic,SonicX,SonicY)
       
       ExamineMouse()
       MineAnimX = MouseX()
       MineAnimY = MouseY()
       
       DisplayAnimSprite(MineAnim, MineAnimX,MineAnimY)

         ; KEYBOARD CHECK
         ;
         ExamineKeyboard()
         If KeyboardPushed(#PB_Key_Right)
            Direction = 1: ;SetFrame(Sonic,1)
            SonicX + 8
            If SonicX > 800: SonicX = -40: EndIf
         EndIf
         If KeyboardPushed(#PB_Key_Left)
            Direction = 2: ;SetFrame(Sonic,8)
            SonicX - 8
            If SonicX < -40: SonicX = 800: EndIf
         EndIf
         If KeyboardPushed(#PB_Key_Up)
            SonicY - 8
            If SonicY < -40: SonicY = 600: EndIf
         EndIf
         If KeyboardPushed(#PB_Key_Down)
            SonicY + 8
            If SonicY > 600: SonicY = -40: EndIf
         EndIf

   ; Update Animation Direction
   SetAnimDirection(Sonic,Direction)

   all = 0
   ; Collision Detection
   For a = 1 To 100
       If RingsHideFlag(a) = 0
          all + 1
          If CollisionAnimAnim(Sonic,SonicX,SonicY,Rings,RingsX(a),RingsY(a))
             R = 100 : G = 100 : B = 100 : RingsHideFlag(a) = 1
          EndIf

       EndIf
   Next a

   CompilerIf #PB_Compiler_OS = #PB_OS_Windows
      If all = 0: Beep_(1400,500):End:EndIf
   CompilerEndIf 

   ExamineKeyboard()
   Delay(1)
Until KeyboardPushed(#PB_Key_Escape)
End

Sonic:
IncludeBinary "Sonic.bmp"
Rings:
IncludeBinary "rings.bmp"
MineAnim:
IncludeBinary "mineanim.bmp"