﻿#ANI_FINDFOLDER   = "#150"
#ANI_FINDFILE     = "#151"
#ANI_FINDCOMPUTER = "#152"
#ANI_COPYFILES    = "#160"
#ANI_COPYFILE     = "#161"
#ANI_RECYCLEFILE  = "#162"
#ANI_DELETEFILE   = "#163"

Procedure AnimateOpen(Gadget, Ani.s,hInstance.l = 0)
  ProcedureReturn SendMessage_(GadgetID(Gadget), #ACM_OPEN, hInstance , Ani)
EndProcedure

Procedure AnimatePlay(Gadget,loop.l = -1, start = 0,ende = -1)
  ProcedureReturn SendMessage_(GadgetID(Gadget),#ACM_PLAY,loop,(start | (ende << 16)))
EndProcedure

Procedure AnimateStop(Gadget)
  ProcedureReturn SendMessage_(GadgetID(Gadget),#ACM_STOP, 0, 0)
EndProcedure

Procedure AnimateGadget(ID,x, y, cx, cy)
  ProcedureReturn CreateGadget(ID, "SysAnimate32", "", #ACS_CENTER | #ACS_TRANSPARENT | #WS_CHILD | #WS_VISIBLE, x, y, cx, cy, 0, 0, 0)
EndProcedure

If OpenWindow(0, #PB_Ignore, 0, 350, 780, "")
  If CreateGadgetList(WindowID(0))
    For I = 0 To 6
      AnimateGadget(I, 15, 60 * I, 330, 80 )
    Next
  EndIf
  AnimateGadget(7, 15, 450, 321, 321 )

  Lib = OpenLibrary(0,"Shell32.dll")

  AnimateOpen(0, #ANI_RECYCLEFILE,Lib)
  AnimateOpen(1, #ANI_FINDFILE,Lib)
  AnimateOpen(2, #ANI_FINDCOMPUTER,Lib)
  AnimateOpen(3, #ANI_COPYFILES,Lib)
  AnimateOpen(4, #ANI_COPYFILE,Lib)
  AnimateOpen(5, #ANI_RECYCLEFILE,Lib)
  AnimateOpen(6, #ANI_DELETEFILE,Lib)

  Path.s{#MAX_PATH}
  GetWindowsDirectory_(@Path, #MAX_PATH)
  AnimateOpen(7, Path + "\Clock.avi")

  For I = 0 To 7
    AnimatePlay(I)
  Next

  Repeat
    Select WaitWindowEvent()
      Case #PB_Event_CloseWindow
        CloseLibrary(0)
        Break
    EndSelect
  ForEver
EndIf
