Enumeration
  #frmMain
  #TG
EndEnumeration

Procedure XML2TreeGadget(oDoc.l)
  
  Static NodeCounter.l
  Static SubLevel.l
  
  If MSXML3_HasChildNodes(oDoc)
    oNodeList = MSXML3_GetChildNodes(oDoc)
    If oNodeList
      For lCounterN = 0 To MSXML3_NodeListGetLength(oNodeList)
        oNode = MSXML3_NodeListGetItem(oNodeList, lCounterN)
        If oNode
          If MSXML3_GetNodeName(oNode) = "#text"
            NodeText$ = "Text: '" + MSXML3_GetText(oNode) + "'"
          Else
            NodeText$ = "<" + MSXML3_GetNodeName(oNode)
            oAttributeList = MSXML3_GetAttributes(oNode)
            If oAttributeList
              For lCounterA = 0 To MSXML3_AttributesGetLength(oAttributeList)
                oAttribute = MSXML3_AttributesGetItem(oAttributeList, lCounterA)
                If oAttribute
                  NodeText$ + " " + MSXML3_GetNodeName(oAttribute) + "=" + Chr(34) + MSXML3_AttributesGetText(oAttribute) + Chr(34)
                  MSXML3_ReleaseObject(oAttribute)
                EndIf
              Next lCounterA
              MSXML3_ReleaseObject(oAttributeList)
            EndIf
            NodeText$ + ">"
          EndIf
         
          AddGadgetItem(#TG, -1, NodeText$, 0, SubLevel)
         
          NodeCounter + 1
         
          If NodeCounter > 50
            While WindowEvent(): Delay(1) : Wend
            NodeCounter = 0
          EndIf
         
          If MSXML3_HasChildNodes(oNode)
            SubLevel + 1
            XML2TreeGadget(oNode)
          Else
            SubLevel - 2
          EndIf           
          
          MSXML3_ReleaseObject(oNode)
         
        EndIf
      Next lCounterN
      MSXML3_ReleaseObject(oNodeList)
    EndIf
  EndIf
 
EndProcedure

If OpenWindow(#frmMain, #PB_Ignore, #PB_Ignore, 500, 500, "XML2TreeGadget-Demo", #PB_Window_ScreenCentered | #PB_Window_SystemMenu)
 
  If CreateGadgetList(WindowID(#frmMain))
   
    TreeGadget(#TG, 0, 0, 500, 500)
   
    oDoc = MSXML3_CreateDomDocument()
   
    If oDoc
      If MSXML3_Load(oDoc, "test2.xml")
        HideGadget(#TG, #True)
        XML2TreeGadget(oDoc)
        HideGadget(#TG, #False)
      Else
        MessageRequester("XML2TreeGadget-Demo", "Couldn't load xmlfile")
      EndIf
      MSXML3_ReleaseObject(oDoc)
    Else
      MessageRequester("XML2TreeGadget-Demo", "Couldn't create xmlobject")
    EndIf
   
    Repeat
     
      WaitWindowEvent = WaitWindowEvent()
      EventGadgetID   = EventGadget()
     
      Select WaitWindowEvent
       
        Case #PB_Event_Gadget
         
          Select EventGadgetID
           
          EndSelect
         
        Case #PB_Event_CloseWindow
          Quit = 1
         
      EndSelect
     
    Until Quit = 1
   
  EndIf
 
EndIf