;XIncludeFile "include/RFile.pbi"

EnableExplicit

; Structur of data in RFile
Structure URLS
  Name.s{40}
  URL.s{50}
EndStructure

Define.URLS Adr
Define.IRFile File
Define.s Text

; create Object
File = New_RFile()
If File
  If File\Open("adress.dat")
    Repeat
      File\Get(#RFile_Next, @Adr); read next record in structured Variable
      With Adr
        Text + \Name + Chr(10)
        Text + \URL + Chr(10) + Chr(10)
      EndWith
    Until File\Eof()
    Text + "Recordcount: " + Str(File\RecCount() + 1) + Chr(10)
    Text + "last modification: " + FormatDate("%yyyy/%mm/%dd", File\LastUpdate())
    MessageRequester(File\VersionStr(), Text)
  Else
    MessageRequester("ERROR", "can't open adress.dat")
  EndIf
  File\Close()
Else
  MessageRequester("ERROR", "can't create RFile-Object")
EndIf
