;XIncludeFile "include/RFile.pbi"

#ICON_SIZE = 246

Procedure BLoad(FileName.s, *MemPointer)
  Protected File.l
  File = ReadFile(#PB_Any, FileName)
  If File
    ReadData(File, *MemPointer, #ICON_SIZE)
    CloseFile(File)
    ProcedureReturn *MemPointer
  EndIf
  ProcedureReturn #False
EndProcedure

; create Object
f.IRFile = New_RFile()

If f\Open("icons.dat") = #False
  f\Create("icons.dat", #ICON_SIZE)
EndIf
Mem = AllocateMemory(f\RecordLength())
If Mem
  Dir = ExamineDirectory(#PB_Any, "icons","*")
  If Dir
    Repeat
      Select NextDirectoryEntry(Dir)
        Case 0
          Break
        Case 1
          IconName.s = DirectoryEntryName(Dir)
          If IconName <> "." And IconName <> ".."
            f\Append(BLoad("icons/" + IconName, Mem))
          EndIf
      EndSelect
    ForEver
    FreeMemory(Mem)
  EndIf
  Debug Str(f\RecCount() + 1) + " records in icons.dat"
  f\Close(); close file and destroy objekt
EndIf
