
If InitSprite() = 0 Or InitKeyboard() = 0 Or InitMouse() = 0
   MessageRequester("ERROR","Cant init DirectX",0):End
EndIf

If OpenScreen(800,600,32,"TEST") = 0    ; test 32bit
 If OpenScreen(800,600,24,"TEST") = 0   ; if 32bit failed, test 24bit
  If OpenScreen(800,600,16,"TEST") = 0  ; if 32/24 failed, try 16bit screen
     MessageRequester("ERROR","Cant open 16/24/32bit Screen",0):End
  EndIf
 EndIf
EndIf

   ; limit Speed
   SetFrameRate(50)

   ; Load Anim-Sprites
   CatchSprite(5,?Car,0)
   TransparentSpriteColor(5,RGB(255,255,255))
   CreateAnimSprite(Car.AnimSprite,5,97,97)
   CarX = (800/2)-97/2
   CarY = (600/2)-97/2

   BackTileX = -200
   BackTileY = -200

Procedure checkerboard()
   CreateSprite(1,1000,800,0)
   StartDrawing(SpriteOutput(1))
     For b = 0 To 3
      For a = 0 To 4
          Box(a*200    ,b*200     , 100, 100,RGB( 00, 00,255))
          Box(a*200+100,b*200     , 100, 100,RGB( 00, 00, 00))
          Box(a*200+100,b*200+100 , 100, 100,RGB( 45, 45,255))
          Box(a*200    ,b*200+100 , 100, 100,RGB(255,255, 00))
      Next a
     Next b
   StopDrawing()
EndProcedure

Procedure loadback()
Shared BackTileX, BackTileY, backbmp$

    LoadImage(1,backbmp$)
    BackTileX = ImageWidth(1)
    BackTileY = ImageHeight(1)

    CreateSprite(1,800+BackTileX,600+BackTileY,0)

    StartDrawing(SpriteOutput(1))
       For b = 0 To (600/BackTileY)+1
         For a = 0 To (800/BackTileX)+1
           DrawImage(1,a*BackTileX,b*BackTileY)
         Next a
       Next b
    
    StopDrawing()
    FreeImage(1)
    BackTileX = -(BackTileX)
    BackTileY = -(BackTileY)

EndProcedure

Procedure load_texture(*pointer)
Shared BackTileX, BackTileY, backbmp$

    CatchImage(1,*pointer)
    BackTileX = ImageWidth(1)
    BackTileY = ImageHeight(1)

    CreateSprite(1,800+BackTileX,600+BackTileY,0)

    StartDrawing(SpriteOutput(1))
       For b = 0 To (600/BackTileY)+1
         For a = 0 To (800/BackTileX)+1
           DrawImage(1,a*BackTileX,b*BackTileY)
         Next a
       Next b
    
    StopDrawing()
    FreeImage(1)
    BackTileX = -(BackTileX)
    BackTileY = -(BackTileY)

EndProcedure



;checkerboard()
;loadback()

load_texture(?Back1): max_speed.f = 24.24
backgroundtexture = 1

;max_speed.f = 20.0

speed.f
Direction = 1
Repeat
    FlipBuffers()
    If IsScreenActive()
       ClearScreen(RGB($66,$66,$66))
       R = 0 : G = 0 : B = 0

       ; KEYBOARD CHECK
       ;
       ExamineKeyboard()
       If KeyboardPushed(#PB_Key_Up)
          If speed = 0.0: speed = 0.75:EndIf
          speed * 1.02 ;speed
          ;speed + 0.05
          If speed > max_speed: speed = max_speed:EndIf
       Else
          speed - 0.15
          If speed < 0: Speed = 0: EndIf
       EndIf
       If KeyboardPushed(#PB_Key_Down)
          speed - 0.8 ; 0.4
          If speed < 0: speed = 0: EndIf
       EndIf

       If KeyboardPushed(#PB_Key_Right)
          If direction_just_changed = 0
             Direction_Changed = 1
          EndIf
       EndIf

       If KeyboardPushed(#PB_Key_Left)
          If direction_just_changed = 0
             Direction_Changed = -1
          EndIf
       EndIf
      

           ;
           ; texture change
           ;
           If KeyboardPushed(#PB_Key_F1)
             If texture_just_changed = 0
                changetexture = 1
             EndIf
           EndIf
           If frame = 20 And changetexture = 1
             backgroundtexture + 1
             If backgroundtexture = 5: backgroundtexture = 1:EndIf
             Select backgroundtexture
               Case 1: tex_pointer = ?Back1 : max_speed = 4.12
               Case 2: tex_pointer = ?Back2 : max_speed = 17.88
               Case 3: tex_pointer = ?Back3 : max_speed = 10.5
               Case 4: tex_pointer = ?Back4 : max_speed = 18.66
             EndSelect
             load_texture(tex_pointer)
             changetexture = 0
             texture_just_changed = 20
          EndIf
          If texture_just_changed > 0
             texture_just_changed - 1
          EndIf



      If frame = 1 Or frame = 10
         If Direction_Changed = 1
            Direction + 1
            direction_just_changed = 2
            NextAnimFrame(Car)
            If Direction = 17: Direction = 1: EndIf
         ElseIf Direction_Changed = -1
            Direction - 1
            direction_just_changed = 2
            PrevAnimFrame(Car)
            If Direction = 0: Direction = 16: EndIf
         EndIf
         Direction_Changed = 0
      EndIf
      If direction_just_changed > 0
         direction_just_changed - 1
      EndIf

      frame + 1
      If frame = 21: frame = 1:EndIf

       Select Direction

          Case 1 : backY + speed
          
          Case 2 : backY + speed        : backX - speed/2
          Case 3 : backY + (speed*0.8)  : backX - (speed*0.8)
          Case 4 : backY + speed/2      : backX - speed

          Case 5 :                      : backX - speed
          
          Case 6 : backY - speed/2      : backX - speed
          Case 7 : backY - (speed*0.8)  : backX - (speed*0.8)
          Case 8 : backY - speed        : backX - speed/2

          Case 9 : backY - speed

          Case 10: backY - speed        : backX + speed/2
          Case 11: backY - (speed*0.8)  : backX + (speed*0.8)
          Case 12: backY - speed/2      : backX + speed

          Case 13:                        backX + speed

          Case 14: backY + speed/2      : backX + speed
          Case 15: backY + (speed*0.8)  : backX + (speed*0.8)
          Case 16: backY + speed        : backX + speed/2
          
       EndSelect

       If backY <= ((BackTileY)-1) : backY = 0 : EndIf
       If backY => 1   : backY = BackTileY : EndIf
       
       If backX <= ((BackTileX)-1) : backX = 0 : EndIf
       If backX => 1   : backX = BackTileX : EndIf

       DisplaySprite(1,backX,backY)
       DisplayAnimSprite(Car,CarX,CarY)
       
       StartDrawing(ScreenOutput())
          A$=StrF(speed,2)
          Select FindString(A$,".",0)
             Case 0:
                  If Len(A$) = 1: A$ = "0"+A$+".00"
                  ElseIf Len(A$) = 2: A$ + ".00": EndIf
             Case 2: A$ = "0"+A$                  
          EndSelect
          ;If Len(A$) = 1 Or Len(A$) = 4: A$ = "0"+A$:EndIf
          ;If Len(A$) = 2: A$ + ".00":EndIf
          FrontColor(0)
          DrawingMode(1)
          DrawText(10,10,"Speed: "+A$)
          DrawText(10,30,"Direction: ");+Using("00",Direction))
          DrawText(10,50,"F1 = change texture (current = "+Str(backgroundtexture)+"/4)")
          DrawText(10,70,"Cursor keys to move...")
          FrontColor(RGB(255,255,255))
          DrawText(11,11,"Speed: "+A$)
          DrawText(11,31,"Direction: ");+Using("00",Direction))
          DrawText(11,51,"F1 = change texture (current = "+Str(backgroundtexture)+"/4)")
           DrawText(11,71,"Cursor keys to move...")
          
          ;Locate(10,50)
          ;DrawText("Time in ms: "+Str(endTime))
       StopDrawing()

       Delay(1)
    Else
       Delay(200)
    EndIf
Until KeyboardPushed(#PB_Key_Escape) Or Quit = 1

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
	Beep_(1400,50): Delay(1500)
CompilerEndIf 

End

Car:
IncludeBinary "Race2.bmp"

Back1:
IncludeBinary "back1.bmp"
Back2:
IncludeBinary "back2.bmp"
Back3:
IncludeBinary "back3.bmp"
Back4:
IncludeBinary "back4.bmp"  