;MessageRequester("Minimal Timer Resolution",Str(GetMinTimerResolution()),0)
;MessageRequester("Maximal Timer Resolution",Str(GetMaxTimerResolution()),0)


If InitSprite() = 0 Or InitKeyboard() = 0 Or InitMouse() = 0
   MessageRequester("ERROR","Cant init DirectX",0):End
EndIf

If OpenScreen(800,600,32,"TEST") = 0      ; test 32bit
  If OpenScreen(800,600,24,"TEST") = 0    ; if 32bit failed, test 24bit
    If OpenScreen(800,600,16,"TEST") = 0  ; if 32/24 failed, try 16bit screen
      MessageRequester("ERROR","Cant open 16/24/32bit Screen",0):End
    EndIf
  EndIf
EndIf

CatchSprite(1,?MouseCursor,0)
CreateAnimSprite(MouseCursor.AnimSprite,1,64,64,40)

MouseLocate(400-32,300-32)

Repeat

     FlipBuffers()
     ExamineKeyboard()
       ClearScreen(0)
       If ExamineMouse()
         MouseX = MouseX() : MouseY = MouseY()
         If MouseX > 800-64 : MouseX = 800-64 : EndIf
         If MouseY > 600-64 : MouseY = 600-64 : EndIf
       Else
         MouseX = 400-32
         MouseY = 300-32
       EndIf
       DisplayAnimSprite(MouseCursor,MouseX,MouseY)

       StartDrawing(ScreenOutput())
         DrawingMode(1):FrontColor(RGB($FF,$FF,$00))

           DrawText(20,20,"Loop Direction: "+Str(AnimLoopDirection(MouseCursor))+" (F1)")

           DrawText(20,45,"Loop Delay: "+Str(AnimLoopDelay(MouseCursor))+" (Cursor left/right)")

           DrawText(20,70,"Frame Count: "+Str(AnimFrameCount(MouseCursor)))
 
           DrawText(20,95,"Direction Count: "+Str(AnimDirectionCount(MouseCursor)))

           DrawText(20,120,"Current Frame: "+Str(CurrentAnimFrame(MouseCursor)))

           DrawText(20,145,"Current Direction: "+Str(CurrentAnimDirection(MouseCursor)))
       StopDrawing()

       If     KeyboardPushed(#PB_Key_F1)
         If F1_pressed=0
          SetAnimLoopDirection(MouseCursor,AnimLoopDirection(MouseCursor)!1)
          F1_pressed = 20
         EndIf
       ElseIf KeyboardPushed(#PB_Key_Right)
          SetAnimLoopDelay(MouseCursor,AnimLoopDelay(MouseCursor)-1)
       ElseIf KeyboardPushed(#PB_Key_Left)
          SetAnimLoopDelay(MouseCursor,AnimLoopDelay(MouseCursor)+1)
       EndIf
       If F1_pressed:F1_pressed-1:EndIf

Until KeyboardPushed(#PB_Key_Escape)
End

MouseCursor:
IncludeBinary "mineanim.bmp"
  