
#DP_COUNT			= #WM_USER+1 	; wParam = count / (optional: lParam = text)
#DP_INIT			= #WM_USER+2 	; wParam = count / lParam = maxi
#DP_TEXT			= #WM_USER+3 	; wParam = text
#DP_FONT			= #WM_USER+4 	; wParam = Font
#DP_COLORBKG	= #WM_USER+5 	; wParam = color background
#DP_HBITMAP		= #WM_USER+6 	; wParam = handle bitmap

#STYLE					= #WS_CHILD | #WS_VISIBLE
#EXSTYLE				= $200
#STYLE_BLUE			= $0000
#STYLE_RED			= $0001
#STYLE_GREEN		= $0002
#STYLE_LIGHTB		= $0003
#STYLE_NOTEXT		= $0000
#STYLE_TEXT			= $0004
#STYLE_PERCENT	= $0008

#EXSTYLE_NONE		= 0

InitCommonControls_()

Import "DrawProgress.lib"
  CreateClass()
EndImport

CreateClass()

Procedure DrawProgress_SetGadgetState(*gadget.PB_Gadget,count.l)
  SendMessage_(*Gadget\gadget,#DP_COUNT,count,0)
EndProcedure

Procedure DrawProgress_SetGadgetText(*gadget.PB_Gadget,Text.s)
  ProcedureReturn SendMessage_(*Gadget\gadget,#DP_TEXT,Text,0)
EndProcedure

Procedure DrawProgressGadget(ID.l,x.l,y.l,cx.l,cy.l,count.l,max.l,flags=0)
  Protected vt.PB_GadgetVT , Handle.l , hWnd.l

  vt\SetGadgetState = @DrawProgress_SetGadgetState()
  vt\SetGadgetText  = @DrawProgress_SetGadgetText()
  Handle = CreateGadget(ID,"DRAWPROGRESS", "",#STYLE|flags, x, y, cx, cy, 0, 0,@vt)

  If id = #PB_Any
    hWnd = GadgetID(Handle)
  Else
    hWnd = Handle
  EndIf

  SendMessage_(hWnd,#DP_INIT,count,Max)

  ProcedureReturn Handle
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 32
; FirstLine = 12
; Folding = -
; EnableXP