
#DEFBCKCOLOR				= $00C0F0F0
#DEFTXTCOLOR				= $00000000
#DEFSELBCKCOLOR		  = $00800000
#DEFSELTXTCOLOR		  = $00FFFFFF
#DEFCMNTCOLOR			  = $02008000
#DEFSTRCOLOR				= $00A00000
#DEFOPRCOLOR				= $000000A0
#DEFHILITE1				  = $00F0C0C0
#DEFHILITE2				  = $00C0F0C0
#DEFHILITE3				  = $00C0C0F0
#DEFSELBARCOLOR		  = $00C0C0C0
#DEFSELBARPEN			  = $00808080
#DEFLNRCOLOR				= $00800000
#DEFNUMCOLOR				= $00808080

;Window styles
#STYLE_NOSPLITT			= $0001			          ;No splitt button
#STYLE_NOLINENUMBER	= $0002			          ;No linenumber button
#STYLE_NOCOLLAPSE		= $0004			          ;No expand/collapse buttons
#STYLE_NOHSCROLL		= $0008			          ;No horizontal scrollbar
#STYLE_NOVSCROLL		= $0010			          ;No vertical scrollbar
#STYLE_NOHILITE			= $0020			          ;No color hiliting
#STYLE_NOSIZEGRIP		= $0040			          ;No size grip
#STYLE_NODBLCLICK		= $0080			          ;No action on double clicks
#STYLE_READONLY			= $0100			          ;Text is locked
#STYLE_NODIVIDERLINE= $0200			          ;Blocks are not divided by line
#STYLE_NOBACKBUFFER	= $0400			          ;Drawing directly to screen DC
#STYLE_NOSTATE			= $0800			          ;No state indicator
#STYLE_DRAGDROP			= $1000			          ;Drag & Drop support, app must load ole
#STYLE_SCROLLTIP		= $2000			          ;Scrollbar tooltip
#STYLE_HILITECOMMENT= $4000			          ;Comments are hilited

#MODE_NORMAL				= $0				          ;Normal
#MODE_BLOCK				  = $1				          ;Block select

;Private edit messages
#REM_RAINIT				  = #WM_USER+9999	      ;wParam=0, lParam=pointer to controls DIALOG struct
#REM_BASE				    = #WM_USER+1000
#REM_SETHILITEWORDS	= #REM_BASE+0		      ;wParam=Color, lParam=lpszWords
#REM_SETFONT				= #REM_BASE+1		      ;wParam=nLineSpacing, lParam=lpRAFONT
#REM_GETFONT				= #REM_BASE+2		      ;wParam=0, lParam=lpRAFONT
#REM_SETCOLOR			  = #REM_BASE+3		      ;wParam=0, lParam=lpRACOLOR
#REM_GETCOLOR			  = #REM_BASE+4		      ;wParam=0, lParam=lpRACOLOR
#REM_SETHILITELINE	= #REM_BASE+5		      ;wParam=Line, lParam=Color
#REM_GETHILITELINE	= #REM_BASE+6		      ;wParam=Line, lParam=0
#REM_SETBOOKMARK		= #REM_BASE+7		      ;wParam=Line, lParam=Type
#REM_GETBOOKMARK		= #REM_BASE+8		      ;wParam=Line, lParam=0
#REM_CLRBOOKMARKS		= #REM_BASE+9		      ;wParam=0, lParam=Type
#REM_NXTBOOKMARK		= #REM_BASE+10		    ;wParam=Line, lParam=Type
#REM_PRVBOOKMARK		= #REM_BASE+11		    ;wParam=Line, lParam=Type
#REM_FINDBOOKMARK		= #REM_BASE+12		    ;wParam=BmID, lParam=0
#REM_SETBLOCKS			= #REM_BASE+13		    ;wParam=[lpLINERANGE], lParam=0
#REM_ISLINE				  = #REM_BASE+14		    ;wParam=Line, lParam=lpszDef
#REM_GETWORD				= #REM_BASE+15		    ;wParam=BuffSize, lParam=lpBuff
#REM_COLLAPSE			  = #REM_BASE+16		    ;wParam=Line, lParam=0
#REM_COLLAPSEALL		= #REM_BASE+17		    ;wParam=0, lParam=0
#REM_EXPAND				  = #REM_BASE+18		    ;wParam=Line, lParam=0
#REM_EXPANDALL			= #REM_BASE+19		    ;wParam=0, lParam=0
#REM_LOCKLINE			  = #REM_BASE+20		    ;wParam=Line, lParam=TRUE/FALSE
#REM_ISLINELOCKED		= #REM_BASE+21		    ;wParam=Line, lParam=0
#REM_HIDELINE			  = #REM_BASE+22		    ;wParam=Line, lParam=TRUE/FALSE
#REM_ISLINEHIDDEN		= #REM_BASE+23		    ;wParam=Line, lParam=0
#REM_AUTOINDENT			= #REM_BASE+24		    ;wParam=0, lParam=TRUE/FALSE
#REM_TABWIDTH			  = #REM_BASE+25		    ;wParam=nChars, lParam=TRUE/FALSE (Expand tabs)
#REM_SELBARWIDTH		= #REM_BASE+26		    ;wParam=nWidth, lParam=0
#REM_LINENUMBERWIDTH= #REM_BASE+27		    ;wParam=nWidth, lParam=0
#REM_MOUSEWHEEL			= #REM_BASE+28		    ;wParam=nLines, lParam=0
#REM_SUBCLASS			  = #REM_BASE+29		    ;wParam=0, lParam=lpWndProc
#REM_SETSPLIT			  = #REM_BASE+30		    ;wParam=nSplit, lParam=0
#REM_GETSPLIT			  = #REM_BASE+31		    ;wParam=0, lParam=0
#REM_VCENTER				= #REM_BASE+32		    ;wParam=0, lParam=0
#REM_REPAINT				= #REM_BASE+33		    ;wParam=0, lParam=TRUE/FALSE (Paint Now)
#REM_BMCALLBACK			= #REM_BASE+34		    ;wParam=0, lParam=lpBmProc
#REM_READONLY			  = #REM_BASE+35		    ;wParam=0, lParam=TRUE/FALSE
#REM_INVALIDATELINE	= #REM_BASE+36		    ;wParam=Line, lParam=0
#REM_SETPAGESIZE		= #REM_BASE+37		    ;wParam=nLines, lParam=0
#REM_GETPAGESIZE		= #REM_BASE+38		    ;wParam=0, lParam=0
#REM_GETCHARTAB			= #REM_BASE+39		    ;wParam=nChar, lParam=0
#REM_SETCHARTAB			= #REM_BASE+40		    ;wParam=nChar, lParam=nValue
#REM_SETCOMMENTBLOCKS= #REM_BASE+41		    ;wParam=lpStart, lParam=lpEnd
#REM_SETWORDGROUP		= #REM_BASE+42		    ;wParam=0, lParam=nGroup (0-15)
#REM_GETWORDGROUP		= #REM_BASE+43		    ;wParam=0, lParam=0
#REM_SETBMID				= #REM_BASE+44		    ;wParam=nLine, lParam=nBmID
#REM_GETBMID				= #REM_BASE+45		    ;wParam=nLine, lParam=0
#REM_ISCHARPOS			= #REM_BASE+46		    ;wParam=CP, lParam=0, returns 1 if comment block, 2 if comment, 3 if string
#REM_HIDELINES			= #REM_BASE+47		    ;wParam=nLine, lParam=nLines
#REM_SETDIVIDERLINE	= #REM_BASE+48		    ;wParam=nLine, lParam=TRUE/FALSE
#REM_ISINBLOCK			= #REM_BASE+49		    ;wParam=nLine, lParam=lpRABLOCKDEF
#REM_TRIMSPACE			= #REM_BASE+50		    ;wParam=nLine, lParam=fLeft
#REM_SAVESEL				= #REM_BASE+51		    ;wParam=0, lParam=0
#REM_RESTORESEL			= #REM_BASE+52		    ;wParam=0, lParam=0
#REM_GETCURSORWORD	= #REM_BASE+53		    ;wParam=BuffSize, lParam=lpBuff
#REM_SETSEGMENTBLOCK= #REM_BASE+54		    ;wParam=nLine, lParam=TRUE/FALSE
#REM_GETMODE				= #REM_BASE+55		    ;wParam=0, lParam=0
#REM_SETMODE				= #REM_BASE+56		    ;wParam=nMode, lParam=0
#REM_GETBLOCK			  = #REM_BASE+57		    ;wParam=0, lParam=lpBLOCKRANGE
#REM_SETBLOCK			  = #REM_BASE+58		    ;wParam=0, lParam=lpBLOCKRANGE
#REM_BLOCKINSERT		= #REM_BASE+59		    ;wParam=0, lParam=lpText
#REM_LOCKUNDOID			= #REM_BASE+60		    ;wParam=TRUE/FALSE, lParam=0
#REM_ADDBLOCKDEF		= #REM_BASE+61		    ;wParam=0, lParam=lpRABLOCKDEF

;Line hiliting
#STATE_HILITEOFF		= 0
#STATE_HILITE1			= 1
#STATE_HILITE2			= 2
#STATE_HILITE3			= 3
#STATE_HILITEMASK	  = 3

;Bookmarks
#STATE_BMOFF				= $00
#STATE_BM1				  = $10
#STATE_BM2				  = $20
#STATE_BM3				  = $30
#STATE_BM4				  = $40
#STATE_BM5				  = $50
#STATE_BM6				  = $60
#STATE_BM7				  = $70
#STATE_BM8				  = $80
#STATE_BMMASK			  = $0F0

;Line states
#STATE_LOCKED			  = $0100
#STATE_HIDDEN			  = $0200
#STATE_COMMENT			= $0400
#STATE_DIVIDERLINE	= $0800
#STATE_SEGMENTBLOCK	= $1000
#STATE_GARBAGE			= $80000000

;Character table types
#CT_NONE					  = $0
#CT_CHAR					  = $1
#CT_OPER					  = $2
#CT_HICHAR				  = $3
#CT_CMNTCHAR				= $4
#CT_STRING				  = $5
#CT_CMNTDBLCHAR			= $6

#BD_NONESTING			  = $01				            ;Set to true for non nested blocks
#BD_DIVIDERLINE			= $02				            ;Draws a divider line
#BD_INCLUDELAST			= $04				            ;lpszEnd line is also collapsed
#BD_LOOKAHEAD			  = $08				            ;Look 500 lines ahead for the ending
#BD_SEGMENTBLOCK		= $10				            ;Segment block, collapse till next segmentblock

#PB_Gadget_SelBackColor     = 3
#PB_Gadget_SelFrontColor    = 4
#PB_Gadget_CommentColor     = 5
#PB_Gadget_StringColor      = 6
#PB_Gadget_OperatorColor    = 7
#PB_Gadget_LineNumberColor  = 8
#PB_Gadget_NumberColor      = 9

Structure RABLOCKDEF
  lpszStart.l						                    ;Block start
  lpszEnd.l						                      ;Block end
  lpszNot1.l						                    ;Dont hide line containing this or set to NULL
  lpszNot2.l						                    ;Dont hide line containing this or set to NULL
  flag.l						                        ;High word is WordGroup(0-15)
EndStructure

Structure LINERANGE
  lnMin.l						                        ;Starting line
  lnMax.l						                        ;Ending line
EndStructure

Structure BLOCKRANGE
  lnMin.l						                        ;Starting line
  clMin.l						                        ;Starting column
  lnMax.l						                        ;Ending line
  clMax.l						                        ;Ending column
EndStructure

Structure RAFONT
  hFont.l						                       ;Code edit normal
  hIFont.l						                     ;Code edit italics
  hLnrFont.l						                   ;Line numbers
EndStructure

Structure RACOLOR
  bckcol.l						                     ;Back color
  txtcol.l						                     ;Text color
  selbckcol.l		      			               ;Sel back color
  seltxtcol.l   						               ;Sel text color
  cmntcol.l						                     ;Comment color
  strcol.l						                     ;String color
  oprcol.l						                     ;Operator color
  hicol1.l						                     ;Line hilite 1
  hicol2.l						                     ;Line hilite 2
  hicol3.l						                     ;Line hilite 3
  selbarbck.l   						               ;Selection bar
  selbarpen.l		    				               ;Selection bar pen
  lnrcol.l						                     ;Line numbers color
  numcol.l						                     ;Numbers & hex color
EndStructure

Structure RASELCHANGE
  nmhdr.NMHDR
  chrg.CHARRANGE 			                     ;Current selection
  seltyp.w						                     ;SEL_TEXT or SEL_OBJECT
  line.l					  	                     ;Line number
  cpLine.l						                     ;Character position of first character
  lpLine.l						                     ;Pointer to line
  nlines.l						                     ;Total number of lines
  nhidden.l						                     ;Total number of hidden lines
  fchanged.l					                     ;TRUE if changed since last
  npage.l						                       ;Page number
  nWordGroup.l				                     ;Hilite word group(0-15)
EndStructure

OleInitialize_(0)

Import "RaEdit.res" : EndImport

Import "masm32.lib" : EndImport

Import "RAEdit.lib"
  InstallRAEdit(hInstance)
  UnInstallRAEdit()
EndImport


hInstance = GetModuleHandle_(0)
InstallRAEdit(hInstance)

; //
; //  SetGadgetColor(Gadget,Index,Color)
; //
; //  Gadget = PBID
; //
; //  Index :
; //  #PB_Gadget_FrontColor       = 1
; //  #PB_Gadget_BackColor        = 2
; //  #PB_Gadget_SelBackColor     = 3
; //  #PB_Gadget_SelFrontColor    = 4
; //  #PB_Gadget_CommentColor     = 5
; //  #PB_Gadget_StringColor      = 6
; //  #PB_Gadget_OperatorColor    = 7
; //  #PB_Gadget_LineNumberColor  = 8
; //  #PB_Gadget_NumberColor      = 9
; //
; //  Color = $000000 <-> $FFFFFF
; //
Procedure RaEdit_SetGadgetColor(*gadget.PB_Gadget,Index,Color)
  Protected RaColor.RACOLOR

  SendMessage_(*gadget\Gadget,#REM_GETCOLOR,0,@RaColor)

  Select Index
    Case #PB_Gadget_FrontColor
      RaColor\txtcol = color
      ProcedureReturn SendMessage_(*gadget\Gadget,#REM_SETCOLOR,0,@RaColor)
    Case #PB_Gadget_BackColor
      RaColor\bckcol = color
      ProcedureReturn SendMessage_(*gadget\Gadget,#REM_SETCOLOR,0,@RaColor)
    Case #PB_Gadget_SelBackColor
      RaColor\selbckcol = color
      ProcedureReturn SendMessage_(*gadget\Gadget,#REM_SETCOLOR,0,@RaColor)
    Case #PB_Gadget_SelFrontColor
      RaColor\seltxtcol = color
      ProcedureReturn SendMessage_(*gadget\Gadget,#REM_SETCOLOR,0,@RaColor)
    Case #PB_Gadget_CommentColor
      RaColor\cmntcol = color
      ProcedureReturn SendMessage_(*gadget\Gadget,#REM_SETCOLOR,0,@RaColor)
    Case #PB_Gadget_StringColor
      RaColor\strcol = color
      ProcedureReturn SendMessage_(*gadget\Gadget,#REM_SETCOLOR,0,@RaColor)
    Case #PB_Gadget_OperatorColor
      RaColor\oprcol = color
      ProcedureReturn SendMessage_(*gadget\Gadget,#REM_SETCOLOR,0,@RaColor)
    Case #PB_Gadget_LineNumberColor
      RaColor\lnrcol = color
      ProcedureReturn SendMessage_(*gadget\Gadget,#REM_SETCOLOR,0,@RaColor)
    Case #PB_Gadget_NumberColor
      RaColor\numcol = color
      ProcedureReturn SendMessage_(*gadget\Gadget,#REM_SETCOLOR,0,@RaColor)
  EndSelect

EndProcedure

; //
; //   SetGadgetAttribute(*gadget.PB_Gadget,Index,Wert)
; //
; //   Index :
; //   #REM_AUTOINDENT
; //   #REM_TABWIDTH
; //   #REM_SETHILITEWORDS
; //   #REM_SETMODE
; //   Wert -> long
; //

Procedure RaEdit_SetGadgetAttribute(*gadget.PB_Gadget,Index,wert)

  If Index = #REM_AUTOINDENT
    ProcedureReturn SendMessage_(*Gadget\gadget,#REM_AUTOINDENT,0,wert)
  EndIf

  If Index = #REM_TABWIDTH
    ProcedureReturn SendMessage_(*Gadget\gadget,#REM_TABWIDTH,wert,#False)
  EndIf

  If Index = #REM_SETHILITEWORDS
    ProcedureReturn SendMessage_(*Gadget\gadget,#REM_SETHILITEWORDS,PeekL(wert),wert+4)
  EndIf

  If Index = #REM_SETMODE
    ProcedureReturn SendMessage_(*Gadget\gadget,#REM_SETMODE,wert,0)
  EndIf

  If Index = #REM_SETSPLIT
    ProcedureReturn SendMessage_(*Gadget\gadget,#REM_SETSPLIT,wert,0)
  EndIf

EndProcedure

; //

Procedure RaEditGadget(ID.l,x.l,y.l,cx.l,cy.l,flags=0)
  Protected vt.PB_GadgetVT , Handle.l

  vt\GadgetType         = #PB_GadgetType_Editor
  vt\SetGadgetColor     = @RaEdit_SetGadgetColor()
  vt\SetGadgetAttribute = @RaEdit_SetGadgetAttribute()
  Handle = CreateGadget(ID,"MyRAEdit", "",#WS_CHILD|#WS_VISIBLE|flags, x, y, cx, cy, #WS_EX_STATICEDGE, 0,@vt)

  ProcedureReturn Handle
EndProcedure
