XIncludeFile "RaGrid.pbi"

;-  AddGridColumn(pbid.l,Text.s,cx.l,typ.l,flags=0) ; set header\column
;-  AddGadgetGridItem(pbid.l,daten.l)               ; set Row
;-  SortGridColumn(pbid.l,col,typ.l = 0)            ; sort column
;-  GetGridRow(pbid.l)                              ; return selected row
;-  GetGridCol(pbid.l)                              ; return selected column
;-  AddGridComboString(pbid.l,col.l,Text.s)

#grid = 1

*hW.Long = OpenWindow(#PB_Any,#PB_Ignore,#PB_Ignore,510,260,"Test")
SmartWindowRefresh(*hW,1)

CreateGadgetList(*hW\l)

GridGadget(#grid,5,5,500,250,#STYLE_NOSEL)

Structure Grid1
  col0.l ; TYPE_EDITLONG
  col1.l ; TYPE_CHECKBOX
  col2.l ; TYPE_DATE
  col3.l ; TYPE_TIME
  col4.l ; TYPE_COMBOBOX
  Hotk.l ; TYPE_HOTKEY
EndStructure

AddGridColumn(#grid,"ID"    ,30,#TYPE_EDITLONG)
AddGridColumn(#grid,"CHECK" ,50,#TYPE_CHECKBOX,#GA_ALIGN_CENTER)
AddGridColumn(#grid,"DATE"  ,70,#TYPE_DATE)
AddGridColumn(#grid,"TIME"  ,70,#TYPE_TIME)
AddGridColumn(#grid,"COMBO" ,70,#TYPE_COMBOBOX)
AddGridColumn(#grid,"HOTKEY" ,70,#TYPE_HOTKEY)

AddGridComboString(#grid,4,"0")
AddGridComboString(#grid,4,"1")
AddGridComboString(#grid,4,"2")
AddGridComboString(#grid,4,"3")
AddGridComboString(#grid,4,"5")

row.Grid1
row\Hotk = #VK_D

For i = 1 To 50
  If i = 5 Or i = 8
    row\col1 = #False  ; no check
    row\col4 = 4       ; <- Combobox Item  0 basis
  Else
    row\col1 = #True
    row\col4 = 0
  EndIf
  row\col0 = i
  AddGadgetGridItem(#grid,row)
Next

typ = #SORT_DESCENDING

Repeat
  WindowEvent = WaitWindowEvent()

  If WindowEvent = #PB_Event_Gadget

    Select EventGadget()
      Case #grid
        Select EventType()
          Case #PB_EventType_Grid_HeaderClick
            Debug "#PB_EventType_Grid_HeaderClick"
            Debug "Gadget : " + Str(EventGadget())
            Debug "CELL : " + Str(GetGridRow(EventGadget())) + ":" + Str(GetGridCol(EventGadget()))

            SortGridColumn(#grid,1,typ)

            If typ = #SORT_ASCENDING
              typ = #SORT_DESCENDING
            Else
              typ = #SORT_ASCENDING
            EndIf

          Case #PB_EventType_Grid_ButtonClick
            Debug "#PB_EventType_Grid_ButtonClick"
            Debug "Gadget : " + Str(EventGadget())
            Debug "CELL : " + Str(GetGridRow(EventGadget())) + ":" + Str(GetGridCol(EventGadget()))
          Case #PB_EventType_Grid_CheckClick
            Debug "#PB_EventType_Grid_CheckClick"
            Debug "Gadget : " + Str(EventGadget())
            Debug "CELL : " + Str(GetGridRow(EventGadget())) + ":" + Str(GetGridCol(EventGadget()))
          Case #PB_EventType_Grid_ImageClick
            Debug "#PB_EventType_Grid_ImageClick"
            Debug "Gadget : " + Str(EventGadget())
            Debug "CELL : " + Str(GetGridRow(EventGadget())) + ":" + Str(GetGridCol(EventGadget()))
          Case #PB_EventType_Grid_BeforeSelChange
            Debug "#PB_EventType_Grid_BeforeSelChange"
            Debug "Gadget : " + Str(EventGadget())
            Debug "CELL : " + Str(GetGridRow(EventGadget())) + ":" + Str(GetGridCol(EventGadget()))
          Case #PB_EventType_Grid_AfterSelChange
            Debug "#PB_EventType_Grid_AfterSelChange"
            Debug "Gadget : " + Str(EventGadget())
            Debug "CELL : " + Str(GetGridRow(EventGadget())) + ":" + Str(GetGridCol(EventGadget()))
          Case #PB_EventType_Grid_BeforeEdit
            Debug "#PB_EventType_Grid_BeforeEdit"
            Debug "Gadget : " + Str(EventGadget())
            Debug "CELL : " + Str(GetGridRow(EventGadget())) + ":" + Str(GetGridCol(EventGadget()))
          Case #PB_EventType_Grid_AfterEdit
            Debug "#PB_EventType_Grid_AfterEdit"
            Debug "Gadget : " + Str(EventGadget())
            Debug "CELL : " + Str(GetGridRow(EventGadget())) + ":" + Str(GetGridCol(EventGadget()))
          Case #PB_EventType_Grid_BeforeUpdate
            Debug "#PB_EventType_Grid_BeforeUpdate"
            Debug "Gadget : " + Str(EventGadget())
            Debug "CELL : " + Str(GetGridRow(EventGadget())) + ":" + Str(GetGridCol(EventGadget()))
          Case #PB_EventType_Grid_AfterUpdate
            Debug "#PB_EventType_Grid_AfterUpdate"
            Debug "Gadget : " + Str(EventGadget())
            Debug "CELL : " + Str(GetGridRow(EventGadget())) + ":" + Str(GetGridCol(EventGadget()))
          Case #PB_EventType_Grid_UserConvert
            Debug "#PB_EventType_Grid_UserConvert"
            Debug "Gadget : " + Str(EventGadget())
            Debug "CELL : " + Str(GetGridRow(EventGadget())) + ":" + Str(GetGridCol(EventGadget()))
        EndSelect
    EndSelect

  EndIf


Until WindowEvent = #WM_CLOSE
