; IncludeFile "pbosl_msxml3.pb"
; 
; CallDebugger
; 
; MSXML3_Init()

xDoc = MSXML3_CreateDomDocument()

If xDoc
  
  sXML.s = "<adressen>" + #CRLF$
  sXML.s + "  <adresse>" + #CRLF$
  sXML.s + "    <name>Donald Duck</name>" + #CRLF$
  sXML.s + "    <strasse>Erpelweg 10</strasse>" + #CRLF$
  sXML.s + "    <ort>Entenhausen</ort>" + #CRLF$
  sXML.s + "  </adresse>" + #CRLF$
  sXML.s + "  <adresse>" + #CRLF$
  sXML.s + "    <name>Batman</name>" + #CRLF$
  sXML.s + "    <strasse>Fledermausgasse 99</strasse>" + #CRLF$
  sXML.s + "    <ort>Gotham City</ort>" + #CRLF$
  sXML.s + "  </adresse>" + #CRLF$
  sXML.s + "</adressen>"
  
  If MSXML3_LoadXML(xDoc, sXML)
    
    MessageRequester("XML erfolgreich in das DOMDocument-Objekt geladen",  MSXML3_GetXml(xDoc))
    
  Else
    
    Msg$ = "ErrorCode: " + Str(MSXML3_GetParseErrorErrorcode(xDoc)) + #CRLF$
    Msg$ + "Beschreibung: " + MSXML3_GetParseErrorReason(xDoc) + #CRLF$
    Msg$ + "Source: " + MSXML3_GetParseErrorSrctext(xDoc) + #CRLF$
    Msg$ + "Fehlerzeile: " + Str(MSXML3_GetParseErrorLine(xDoc)) + #CRLF$
    Msg$ + "Fehlerposition: " + Str(MSXML3_GetParseErrorLinepos(xDoc)) + #CRLF$
    
    MessageRequester("XML konnte nicht in das DOMDocument-Objekt geladen werden", Msg$)
    
  EndIf
  
  MSXML3_ReleaseObject(xDoc)
  
Else
  
  MessageRequester("Initialisierung fehlgeschlagen", "Es konnte kein DOMDocument-Objekt erstellt werden")
  
EndIf

